diff -urN fltk-1.1.6.orig/src/Fl_Gl_Choice.H fltk-1.1.6/src/Fl_Gl_Choice.H
--- fltk-1.1.6.orig/src/Fl_Gl_Choice.H	2004-09-09 17:34:46.000000000 -0400
+++ fltk-1.1.6/src/Fl_Gl_Choice.H	2004-12-16 12:42:23.387285500 -0500
@@ -124,6 +124,7 @@
 void fl_set_gl_context(Fl_Window*, GLContext);
 void fl_no_gl_context();
 void fl_delete_gl_context(GLContext);
+void fl_hide_gl_context(GLContext context);
 
 #endif
 
diff -urN fltk-1.1.6.orig/src/Fl_Gl_Choice.cxx fltk-1.1.6/src/Fl_Gl_Choice.cxx
--- fltk-1.1.6.orig/src/Fl_Gl_Choice.cxx	2004-09-24 12:00:10.000000000 -0400
+++ fltk-1.1.6/src/Fl_Gl_Choice.cxx	2004-12-16 12:42:23.402911200 -0500
@@ -435,6 +435,21 @@
   del_context(context);
 }
 
+
+void fl_hide_gl_context(GLContext context) {
+  cached_context = 0;
+  cached_window = 0;
+# if defined(__APPLE_QD__)
+  aglSetCurrentContext(0);
+  aglSetDrawable( context, NULL );
+#  elif defined(__APPLE_QUARTZ__)
+  // warning: the Quartz version should probably use Core GL (CGL) instead of AGL
+  aglSetCurrentContext(0);
+  aglSetDrawable( context, NULL );
+#  endif
+}
+
+
 #endif // HAVE_GL
 
 
diff -urN fltk-1.1.6.orig/src/Fl_Gl_Window.cxx fltk-1.1.6/src/Fl_Gl_Window.cxx
--- fltk-1.1.6.orig/src/Fl_Gl_Window.cxx	2004-09-09 17:34:46.000000000 -0400
+++ fltk-1.1.6/src/Fl_Gl_Window.cxx	2004-12-16 12:42:23.418536900 -0500
@@ -408,7 +415,12 @@
 }    
 
 void Fl_Gl_Window::hide() {
+#if defined(__APPLE_QD__)  ||  defined(__APPLE_QUARTZ__)
+  fl_hide_gl_context((GLContext) context());
+#else
   context(0);
+#endif
+
 #if HAVE_GL_OVERLAY && defined(WIN32)
   if (overlay && overlay != this) {
     fl_delete_gl_context((GLContext)overlay);
@@ -419,6 +431,7 @@
 }
 
 Fl_Gl_Window::~Fl_Gl_Window() {
+  context(0);
   hide();
 //  delete overlay; this is done by ~Fl_Group
 }
